/////////////////////////////////////////////////////////////////////////////
// LppStream.hh - C++ stream style I/O for Lpp.

#ifndef LPPSTREAM_H
#define LPPSTREAM_H

#include "Lpp.hh"
#include <stream.h>

/////////////////////////////////////////////////////////////////////////////
// Stream argument functions.

typedef let (*Lpp_fp2_ostream)(let, ostream&);

class Function2_ostream : private Function {
  let (*functionM)(let, ostream&); Function2_ostream(Lpp_fp2_ostream);
public:
  friend let Lpp_C(Lpp_fp2_ostream); friend let funcall(let, let, ostream&);};

/////////////////////////////////////////////////////////////////////////////
// Output to C++ streams.

let princ(let, ostream&); let prin1(let, ostream&); let print(let, ostream&);
void pprint(let, ostream&); void pprint(let, ostream&, int, int);
const char* princ(const char*, ostream&);
const char* prin1(const char*, ostream&);
const char* print(const char*, ostream&);
let terpri(ostream&); let finishOutput(ostream&);

/////////////////////////////////////////////////////////////////////////////
// Input from C++ streams.

let read(istream&);

/////////////////////////////////////////////////////////////////////////////
// A special macro with class to dispatch on prin1() from << operator.

#ifndef LPP_O_NODEFINE
#define O Lpp_O
#endif

class Lpp_Prin1Rep : public Lpp {public: Lpp_Prin1Rep();};
#define Lpp_O(EXP) ((Lpp_Prin1Rep*) EXP)

/////////////////////////////////////////////////////////////////////////////
// Overloaded stream operators.

ostream& operator<<(ostream&, let);
ostream& operator<<(ostream&, Lpp_Prin1Rep*);

/////////////////////////////////////////////////////////////////////////////
#endif LPPSTREAM_H
